<?php

//---------------------------------------------------------------------------
// jrhelper.php
// by mouser@donationcoder.com, mar 1. 2010
//---------------------------------------------------------------------------











//---------------------------------------------------------------------------
// from http://www.php.net/print_r

function jr_DumpArray($title, &$resultdata)
{
	// return html table code dumping table(s) contained in resultdaa
	// basically just print_r but for html
	if ($title=='')
		$retv='';
	else
		$retv = $title . '';
	$retv .= jr_i_dump($resultdata);
	return $retv;
}


function jr_i_dump(&$var, $info = FALSE)
{
    $scope = false;
    $prefix = 'unique';
    $suffix = 'value';
 
		echo 'HERE IN JRIDUMP';

    if($scope) $vals = $scope;
    else $vals = $GLOBALS;

    $old = $var;
    $var = $new = $prefix.rand().$suffix; $vname = FALSE;
    foreach($vals as $key => $val) if($val === $new) $vname = $key;
    $var = $old;

    $retv ="";
    if ($info != FALSE) $retv .= "$info:\n";
    $retv .= jr_i_do_dump($var, '$'.$vname);
    $retv .= "";
		return $retv;
}

////////////////////////////////////////////////////////
// Function:         do_dump
// Inspired from:     PHP.net Contributions
// Description: Better GI than print_r or var_dump

function jr_i_do_dump(&$var, $var_name = NULL, $indent = NULL, $reference = NULL)
{
    $do_dump_indent = " ";
    $reference = $reference.$var_name;
    $keyvar = 'the_do_dump_recursion_protection_scheme'; $keyname = 'referenced_object_name';
		$retv = '';

    if (is_array($var) && isset($var[$keyvar]))
    {
        $real_var = &$var[$keyvar];
        $real_name = &$var[$keyname];
        $type = ucfirst(gettype($real_var));
        $retv .= "$indent$var_name $type = $real_name\n";
    }
    else
    {
        $var = array($keyvar => $var, $keyname => $reference);
        $avar = &$var[$keyvar];
   
        $type = ucfirst(gettype($avar));
        if($type == "String") $type_color = "<span style='color:green'>";
        elseif($type == "Integer") $type_color = "<span style='color:red'>";
        elseif($type == "Double"){ $type_color = "<span style='color:#0099c5'>"; $type = "Float"; }
        elseif($type == "Boolean") $type_color = "<span style='color:#92008d'>";
        elseif($type == "NULL") $type_color = "<span style='color:black'>";
				$type_color = '';
   
        if(is_array($avar))
        {
            $count = count($avar);
            $retv .= "$indent" . ($var_name ? "$var_name => ":"") . "$type ($count)\n$indent(\n";
            $keys = array_keys($avar);
            foreach($keys as $name)
            {
                $value = &$avar[$name];
                $retv .= jr_i_do_dump($value, "['$name']", $indent.$do_dump_indent, $reference);
            }
            $retv .= "$indent)\n";
        }
        elseif(is_object($avar))
        {
            $retv .= "$indent$var_name $type\n$indent(\n";
            foreach($avar as $name=>$value) $retv .= jr_i_do_dump($value, "$name", $indent.$do_dump_indent, $reference);
            $retv .= "$indent)\n";
        }



        elseif(false && is_int($avar)) $retv .= "$indent$var_name = $type(".strlen($avar).") $type_color$avar\n";
        elseif(false && is_string($avar)) $retv .= "$indent$var_name = $type(".strlen($avar).") $type_color\"" . $avar . "\"\n";
        elseif(is_int($avar)) $retv .= "$indent$var_name = $type_color$avar\n";
        elseif(is_string($avar)) $retv .= "$indent$var_name = $type_color\"" . $avar . "\"\n";
        elseif(is_float($avar)) $retv .= "$indent$var_name = $type(".strlen($avar).") $type_color$avar\n";
        elseif(is_bool($avar)) $retv .= "$indent$var_name = $type(".strlen($avar).") $type_color".($avar == 1 ? "TRUE":"FALSE")."\n";
        elseif(is_null($avar)) $retv .= "$indent$var_name = $type(".strlen($avar)."){$type_color}NULL\n";
        else $retv .= "$indent$var_name = $type(".strlen($avar).") $avar\n";

        $var = $var[$keyvar];
    }
	return $retv;
}



function jr_SimpleKeyArrayDump(&$ar)
{
	// make a simple key->value string
	$retv = '';
	if (empty($ar))
		return '';
	foreach ($ar as $key=>$val)
		{
		if (!is_array($val))
			{
			if (empty($retv))
				$retv = '[' . $key . '=>' . $val;
			else
				$retv .= ' , ' . $key . '=>' . $val;
			}
		else
			{
			if (empty($retv))
				$retv = '[' . $key . '[] = ';
			else
				$retv .= ' , ' . $key . '[] = ';
			$retv .= jr_SimpleKeyArrayDump($val);
			}
		}
	$retv .= ']';
	return $retv;
}


function jr_SimpleKeyArrayDumpNl(&$ar,$endl="\n")
{
	// make a simple key->value string
	$retv = '';
	foreach ($ar as $key=>$val)
		{
		$retv .= ' ' . $key . ' => ' . $val . $endl;
		}

	return $retv;
}
//---------------------------------------------------------------------------




